

<?php
/* 
 * Generated by CRUDigniter v2.3 Beta 
 * www.crudigniter.com
 */
 
class Dashboard_model extends CI_Model
{
	
	
    function __construct()
    {
        parent::__construct();
		$this->load->database();
		$this->load->helper('url');

    }
    
    /* function to get MQ or MQL */
	function getDashboarData($level="",$tahun=""){
			if($tahun==""){
				$tahun =date("Y");
			}
			
			$query =  $this->db->query("select 'Total Sales' title, count(*) total from tbl_user where 1
				UNION
				select 'Total Konsumen' title, count(*) total from tbl_konsumen
				UNION
				select 'Total Produk Terjual' title, sum(qty) total 
					FROM tbl_prospect_detail,tbl_prospect 
					WHERE tbl_prospect.id_prospect = tbl_prospect_detail.id_prospect
					AND tbl_prospect_detail.`status` ='deal'
					AND year(tbl_prospect.tgl_po) ='".$tahun."'
				UNION
				select 'Total Deal' title, count(*) total from tbl_prospect 
					WHERE year(tgl_po) ='".$tahun."'	
				UNION
				select 'Total Prospect' title, count(*) total from tbl_prospect 
					WHERE year(tgl_po) ='".$tahun."'
				
				
				");
				/*UNION select 'Total Omzet' title, sum(qty*harga_satuan) total 
					FROM tbl_prospect_detail,tbl_prospect 
					WHERE tbl_prospect.id_prospect = tbl_prospect_detail.id_prospect
					AND tbl_prospect_detail.`status` ='deal'
					AND year(tbl_prospect.tgl_po) ='".$tahun."'*/
				
			
			return $query;
		
		
		
	}

	function getGrafikOmzet($tahun="",$id_user=""){
		if($id_user !=""){
			$condreal = " AND  ( tbl_prospect.id_user ) = '".$id_user."' "; 
			$condtarget = " AND tbl_target.id_user='".$id_user."' "; 
		}else{
			$condreal = "";
			$condtarget ="";
		}
		$query = $this->db->query("SELECT	
'Realisasi' title,
		sum(if(bln=1,total,0)) as Jan, 
		sum(if(bln=2,total,0)) as Feb,
		sum(if(bln=3,total,0)) as Mar,
		sum(if(bln=4,total,0)) as Apr,
		sum(if(bln=5,total,0)) as Mei,
		sum(if(bln=6,total,0)) as Jun,
		sum(if(bln=7,total,0)) as Jul,
		sum(if(bln=8,total,0)) as Agus,
		sum(if(bln=9,total,0)) as Sept,
		sum(if(bln=10,total,0)) as Okt,
		sum(if(bln=11,total,0)) as Nov,
		sum(if(bln=12,total,0)) as Des 
	FROM
		(
	SELECT
		MONTH ( tbl_prospect.tgl_PO ) bln,
		YEAR ( tbl_prospect.tgl_PO ) thn,
		sum( qty * harga_satuan ) total 
	FROM
		tbl_prospect_detail,
		tbl_prospect
		LEFT JOIN tbl_user ON tbl_user.id_user =  tbl_prospect.id_user
	WHERE
		tbl_prospect_detail.`status` = 'deal' 
		AND tbl_prospect.id_prospect = tbl_prospect_detail.id_prospect 
		AND YEAR ( tbl_prospect.tgl_PO ) = '".$tahun."'
		".$condreal ."
	GROUP BY MONTH ( tbl_prospect.tgl_PO )	  
		) totalPendapatan  
	
	UNION SELECT
		'Target',
		sum(target_januari) Jan,
		sum(target_februari) Feb,
		sum(target_maret) Mar,
		sum(target_april) Apr,
		sum(target_mei) Mei,
		sum(target_juni) Jun,
		sum(target_juli) Jul,
		sum(target_agustus) Agu,
		sum(target_september) Sept,
		sum(target_oktober) Okt,
		sum(target_november) Nov,
		sum(target_desember) Des
	FROM `tbl_target`
	WHERE tahun = '".$tahun."'
	".$condtarget ."
	");
		return $query;
	}
	function getGrafikOmzetRange($start="",$end="",$id_user=""){
		if($id_user !=""){
			$condreal = " AND  ( tbl_prospect.id_user ) = '".$id_user."' "; 
			$condtarget = " AND tbl_target.id_user='".$id_user."' "; 
		}else{
			$usercond1 = "";
			$condtarget ="";
		}
		$query = $this->db->query("SELECT	
'Realisasi' title,
		sum(if(bln=1,total,0)) as Jan, 
		sum(if(bln=2,total,0)) as Feb,
		sum(if(bln=3,total,0)) as Mar,
		sum(if(bln=4,total,0)) as Apr,
		sum(if(bln=5,total,0)) as Mei,
		sum(if(bln=6,total,0)) as Jun,
		sum(if(bln=7,total,0)) as Jul,
		sum(if(bln=8,total,0)) as Agus,
		sum(if(bln=9,total,0)) as Sept,
		sum(if(bln=10,total,0)) as Okt,
		sum(if(bln=11,total,0)) as Nov,
		sum(if(bln=12,total,0)) as Des 
	FROM
		(
	SELECT
		MONTH ( tbl_prospect.tgl_PO ) bln,
		YEAR ( tbl_prospect.tgl_PO ) thn,
		sum( qty * harga_satuan ) total 
	FROM
		tbl_prospect_detail,
		tbl_prospect
		LEFT JOIN tbl_user ON tbl_user.id_user =  tbl_prospect.id_user
	WHERE
		tbl_prospect_detail.`status` = 'deal' 
		AND tbl_prospect.id_prospect = tbl_prospect_detail.id_prospect 
		AND   tbl_prospect.tgl_PO  between '".$start."' and '".$end."'
		".$condreal ."
	GROUP BY MONTH ( tbl_prospect.tgl_PO )	  
		) totalPendapatan  
	
	UNION SELECT
		'Target',
		sum(target_januari) Jan,
		sum(target_februari) Feb,
		sum(target_maret) Mar,
		sum(target_april) Apr,
		sum(target_mei) Mei,
		sum(target_juni) Jun,
		sum(target_juli) Jul,
		sum(target_agustus) Agu,
		sum(target_september) Sept,
		sum(target_oktober) Okt,
		sum(target_november) Nov,
		sum(target_desember) Des
	FROM `tbl_target`
	WHERE tahun between year('".$start."') and year('".$end."')
	".$condtarget ."
	");
		return $query;
	}
	function getTopSalesOmzet($tahun="",$orderby="DESC",$limit="5"){
		$query = $this->db->query("
						SELECT
							* 
						FROM
							(
						SELECT
							tbl_user.id_user,
							tbl_user.nama_user,
							YEAR ( tbl_prospect.tgl_PO ) thn,
							tbl_target.target_tahun target,
							sum(qty * harga_satuan  ) total  
						FROM
							tbl_user
							LEFT JOIN tbl_prospect ON tbl_user.id_user = tbl_prospect.id_user 
							AND YEAR ( tbl_prospect.tgl_PO ) = '".$tahun."'
							LEFT JOIN tbl_prospect_detail ON tbl_prospect.id_prospect = tbl_prospect_detail.id_prospect 
							AND tbl_prospect_detail.`status` = 'deal'
							LEFT JOIN tbl_target ON tbl_user.id_user = tbl_target.id_user 
							AND tbl_target.tahun = '".$tahun."' 
						WHERE
							1 
						GROUP BY
							tbl_user.id_user  
							) totalPendapatan 
						ORDER BY
							total ".$orderby."
						LIMIT 0,$limit;
								");
		return $query;
	}
	function getSalesOmzet($tahun="",$orderby="DESC",$limit="5"){
		$query = $this->db->query("
						SELECT
							* 
						FROM
							(
						SELECT
							tbl_user.id_user,
							tbl_user.nama_user,
							YEAR ( tbl_prospect.tgl_PO ) thn,
							tbl_target.target_tahun target,
							(target_januari) tJan,
							(target_februari) tFeb,
							(target_maret) tMar,
							(target_april) tApr,
							(target_mei) tMei,
							(target_juni) tJun,
							(target_juli) tJul,
							(target_agustus) tAgu,
							(target_september) tSept,
							(target_oktober) tOkt,
							(target_november) tNov,
							(target_desember) tDes,
							sum(qty * harga_satuan  ) total ,
							sum(if(MONTH ( tbl_prospect.tgl_PO )=1,(qty * harga_satuan),0 )) Jan,
							sum(if(MONTH ( tbl_prospect.tgl_PO )=2,(qty * harga_satuan),0 )) Feb,
							sum(if(MONTH ( tbl_prospect.tgl_PO )=3,(qty * harga_satuan),0 )) Mar,
							sum(if(MONTH ( tbl_prospect.tgl_PO )=4,(qty * harga_satuan),0 )) Apr,
							sum(if(MONTH ( tbl_prospect.tgl_PO )=5,(qty * harga_satuan),0 )) Mei,
							sum(if(MONTH ( tbl_prospect.tgl_PO )=6,(qty * harga_satuan),0 )) Jun,
							sum(if(MONTH ( tbl_prospect.tgl_PO )=7,(qty * harga_satuan),0 )) Jul,
							sum(if(MONTH ( tbl_prospect.tgl_PO )=8,(qty * harga_satuan),0 )) Agu,
							sum(if(MONTH ( tbl_prospect.tgl_PO )=9,(qty * harga_satuan),0 )) Sept,
							sum(if(MONTH ( tbl_prospect.tgl_PO )=10,(qty * harga_satuan),0 )) Okt,
							sum(if(MONTH ( tbl_prospect.tgl_PO )=11,(qty * harga_satuan),0 )) Nov,
							sum(if(MONTH ( tbl_prospect.tgl_PO )=12,(qty * harga_satuan),0 )) Des
						FROM
							tbl_user
							LEFT JOIN tbl_prospect ON tbl_user.id_user = tbl_prospect.id_user 
							AND YEAR ( tbl_prospect.tgl_PO ) = '".$tahun."'
							LEFT JOIN tbl_prospect_detail ON tbl_prospect.id_prospect = tbl_prospect_detail.id_prospect 
							AND tbl_prospect_detail.`status` = 'deal'
							LEFT JOIN tbl_target ON tbl_user.id_user = tbl_target.id_user 
							AND tbl_target.tahun = '".$tahun."' 
						WHERE
							1 
						GROUP BY
							tbl_user.id_user  
							) totalPendapatan 
						ORDER BY
							total ".$orderby."
						LIMIT 0,$limit;
								");
		return $query;
	}
	function getTopProduct($tahun="",$orderby="DESC",$limit="5"){
		$query = $this->db->query("
						SELECT
							* 
						FROM
							(
						SELECT
							tbl_product.id_product,
							tbl_product.nama_product,
							YEAR ( tbl_prospect.tgl_PO ) thn, 
							sum( tbl_prospect_detail.qty * tbl_prospect_detail.harga_satuan ) total 
						FROM
							tbl_product  
							LEFT JOIN tbl_prospect_detail ON tbl_product.id_product = tbl_prospect_detail.id_product AND tbl_prospect_detail.`status` = 'deal'
							JOIN tbl_prospect ON tbl_prospect.id_prospect = tbl_prospect_detail.id_prospect
						WHERE
							YEAR ( tbl_prospect.tgl_PO ) = '".$tahun."'
						GROUP BY
							tbl_product.id_product
							) totalPenjualan
						ORDER BY
							total ".$orderby."
						LIMIT 0,".$limit.";
								");
		return $query;
	}
	
	
	/* function for resume data transaksi	*/
	function GetTransaksi($condition=""){
		$query =  $this->db->query("select 
data_grafik.tanggal_transaksi,
SUM(if(kode='L1',(jmlh_PL+jmlh_PS),0)) trx_L1,
SUM(if(kode='L2',(jmlh_PL+jmlh_PS),0)) trx_L2,
SUM(if(kode='L3',(jmlh_PL+jmlh_PS),0)) trx_L3,
SUM(if(kode='L4',(jmlh_PL+jmlh_PS),0)) trx_L4,
SUM(if(kode='L5',(jmlh_PL+jmlh_PS),0)) trx_L5,
SUM(if(kode='L6',(jmlh_PL+jmlh_PS),0)) trx_L6
from
(SELECT 
SUBSTR(view_transaksi.id_user FROM 1 FOR 2)kode, 
view_transaksi.tanggal_transaksi,
sum(if( view_transaksi.jenis_transaksi ='PL',(kelas_ist + kelas_spr + kelas_a + kelas_b + kelas_c + kelas_d ),0)) jmlh_PL,
sum(if( view_transaksi.jenis_transaksi ='PS',(kelas_ist + kelas_spr + kelas_a + kelas_b + kelas_c + kelas_d ),0)) jmlh_PS
FROM 
`view_transaksi`
WHERE view_transaksi.jenis_order like '%Domba%'
GROUP BY 
view_transaksi.tanggal_transaksi,kode) data_grafik
group by tanggal_transaksi
		");
		
		return $query->result_array();
	}
	
	 
	
	/*function for get berita*/
	function getBerita($id_user,$level){
		$query="SELECT * FROM tbl_berita 
		WHERE date_expired >= curdate() 
		AND id_level_tujuan >= '%".$level."%'  
		AND SUBSTR(id_user_post FROM 1 FOR (6-id_level_tujuan)) = SUBSTR('".$id_user."' FROM 1 FOR (6-id_level_tujuan))";
		$query =  $this->db->query($query);				
		return $query->result();
		
	}

	function insert_activity($action,$data){
		return $this->db->insert("tbl_activity",array(
							'id_user'=>$this->session->userdata('id_user'),
							'action'=>$action,
							'data'=>$data,
							'datetime'=>date('Y-m-d H:i:s'))
						);

	}

}